
# The normal* variables refer to the standard packaging.
# The compattwo* variables refer to a newer compat packages.
# The compat* variables refer to the compat packages.
%global         globrelease 5

%global         normalver 3.8.2
%global         normalso  18

%global         compatver 3.2.5
%global         compatso  12

%global         compattwover 3.4.0
%global         compattwoso  14

%global         compatthreever 3.7.1
%global         compatthreeso  17



Name:           activemq-cpp
Version:        %{normalver}
Release:        %{globrelease}%{?dist}
Summary:        C++ implementation of JMS-like messaging client

Group:          Development/Libraries
License:        ASL 2.0
URL:            http://activemq.apache.org/cms/
Source0:        http://www.apache.org/dist/activemq/activemq-cpp/source/activemq-cpp-library-%{normalver}-src.tar.gz
Source1:        http://www.apache.org/dist/activemq/activemq-cpp/source/activemq-cpp-library-%{compatver}-src.tar.gz
Source2:        http://www.apache.org/dist/activemq/activemq-cpp/source/activemq-cpp-library-%{compattwover}-src.tar.gz
Source3:        http://www.apache.org/dist/activemq/activemq-cpp/source/activemq-cpp-library-%{compatthreever}-src.tar.gz
# Some local texmf configuration to increase default pool_size.
Patch1:         %{name}-local-texmf.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  doxygen
BuildRequires:  graphviz
BuildRequires:  openssl-devel
%if %{?fedora}%{!?fedora:0} >= 9 || %{?rhel}%{!?rhel:0} >= 6
BuildRequires:  tex(latex)
%else
BuildRequires:  tetex-latex
%endif

BuildRequires:  apr-util-devel%{?_isa} >= 1.3
BuildRequires:  cppunit-devel%{?_isa} >= 1.10.2

%if %{?fedora}%{!?fedora:0} >= 12 || %{?rhel}%{!?rhel:0} >= 6
BuildRequires:  libuuid-devel%{?_isa}
%else
BuildRequires:  e2fsprogs-devel%{?_isa}
%endif

%description
activemq-cpp is a JMS-like API for C++ for interfacing with Message 
Brokers such as Apache ActiveMQ.  C++ messaging service helps to make your 
C++ client code much neater and easier to follow. To get a better feel for 
CMS try the API Reference. 
ActiveMQ-CPP is a client only library, a message broker such as Apache 
ActiveMQ is still needed for your clients to communicate.  

%package devel
Summary:        C++ implementation header files for JMS-like messaging
Group:          Development/Libraries
Requires:       %{name} = %{normalver}-%{globrelease}%{?dist}
Requires:       pkgconfig
%if %{?fedora}%{!?fedora:0} >= 12 || %{?rhel}%{!?rhel:0} >= 6
Requires:  libuuid-devel%{?_isa}
%else
Requires:  e2fsprogs-devel%{?_isa}
%endif

%description devel
activemq-cpp is a JMS-like API for C++ for interfacing with Message 
Brokers such as Apache ActiveMQ.  C++ messaging service helps to make 
your C++ client code much neater and easier to follow. To get a better
feel for CMS try the API Reference.  ActiveMQ-CPP is a client only 
library, a message broker such as Apache ActiveMQ is still needed 
for your clients to communicate.  

%{name}-devel contains development header files.


%package doc
Summary:        C++ implementation header files for JMS-like messaging
Group:          Documentation
%if %{?fedora}%{!?fedora:0} >= 10 || %{?rhel}%{!?rhel:0} >= 6
BuildArch:      noarch
%endif

%description doc
activemq-cpp is a JMS-like API for C++ for interfacing with Message 
Brokers such as Apache ActiveMQ.  C++ messaging service helps to make 
your C++ client code much neater and easier to follow. To get a better
feel for CMS try the API Reference.  ActiveMQ-CPP is a client only 
library, a message broker such as Apache ActiveMQ is still needed 
for your clients to communicate.  

%{name}-doc contains api documentation.

%package compat
Version:        %{compatver}
Release:        %{globrelease}%{?dist}
Summary:        C++ implementation of JMS-like messaging client
Group:          Development/Libraries

%description compat
activemq-cpp is a JMS-like API for C++ for interfacing with Message 
Brokers such as Apache ActiveMQ.  C++ messaging service helps to make your 
C++ client code much neater and easier to follow. To get a better feel for 
CMS try the API Reference. 
ActiveMQ-CPP is a client only library, a message broker such as Apache 
ActiveMQ is still needed for your clients to communicate.  

This package contains activemq-cpp libraries for applications to bind to.

%package -n activemq-cpp%{compattwover}-compat
Version:        %{compattwover}
Release:        %{globrelease}%{?dist}
Summary:        C++ implementation of JMS-like messaging client
Group:          Development/Libraries

%description -n  activemq-cpp%{compattwover}-compat
activemq-cpp is a JMS-like API for C++ for interfacing with Message 
Brokers such as Apache ActiveMQ.  C++ messaging service helps to make your 
C++ client code much neater and easier to follow. To get a better feel for 
CMS try the API Reference. 
ActiveMQ-CPP is a client only library, a message broker such as Apache 
ActiveMQ is still needed for your clients to communicate.  

This package contains activemq-cpp libraries for applications to bind to.

%package -n activemq-cpp%{compatthreever}-compat
Version:        %{compatthreever}
Release:        %{globrelease}%{?dist}
Summary:        C++ implementation of JMS-like messaging client
Group:          Development/Libraries

%description -n  activemq-cpp%{compatthreever}-compat
activemq-cpp is a JMS-like API for C++ for interfacing with Message 
Brokers such as Apache ActiveMQ.  C++ messaging service helps to make your 
C++ client code much neater and easier to follow. To get a better feel for 
CMS try the API Reference. 
ActiveMQ-CPP is a client only library, a message broker such as Apache 
ActiveMQ is still needed for your clients to communicate.  

This package contains activemq-cpp libraries for applications to bind to.


%prep
#extract source1 as well 0 , the compat lib.
%setup -q -n activemq-cpp-library-%{normalver} -a 1 -a 2 -a 3
pushd activemq-cpp-library-%{compatver}
%patch1 -p1
chmod 644 LICENSE.txt
chmod 644 src/main/activemq/transport/mock/MockTransport.cpp
popd
pushd activemq-cpp-library-%{compattwover}
%patch1 -p1
chmod 644 LICENSE.txt
chmod 644 src/main/activemq/transport/mock/MockTransport.cpp
popd

pushd activemq-cpp-library-%{compatthreever}
%patch1 -p1
chmod 644 LICENSE.txt
chmod 644 src/main/activemq/transport/mock/MockTransport.cpp
popd


%patch1 -p1
chmod 644 LICENSE.txt
chmod 644 src/main/activemq/transport/mock/MockTransport.cpp


%build
pushd activemq-cpp-library-%{compatver}
%configure --disable-static --disable-doxygen-html --enable-doxygen-pdf
make %{?_smp_mflags}
popd
pushd activemq-cpp-library-%{compattwover}
%configure --disable-static --disable-doxygen-html --enable-doxygen-pdf
make %{?_smp_mflags}
popd

pushd activemq-cpp-library-%{compatthreever}
%configure --disable-static --disable-doxygen-html --enable-doxygen-pdf
make %{?_smp_mflags}
popd



# Build pdf(30MB) rather than default html(400MB). 
%configure --disable-static --disable-doxygen-html --enable-doxygen-pdf
make %{?_smp_mflags}
make %{?_smp_mflags}  doxygen-run
cp -p texmf.cnf doc/latex/texmf.cnf
make %{?_smp_mflags} doxygen-pdf


%install
rm -rf $RPM_BUILD_ROOT
pushd activemq-cpp-library-%{compatver}
make install DESTDIR=$RPM_BUILD_ROOT
rm $RPM_BUILD_ROOT/%{_libdir}/lib%{name}.la
rm $RPM_BUILD_ROOT/%{_bindir}/example
# Remove the devel files from the compat package
# we only one the runtime stuff.
rm $RPM_BUILD_ROOT/%{_bindir}/activemqcpp-config
rm -rf $RPM_BUILD_ROOT/%{_includedir}/activemq-cpp-%{compatver}
rm  $RPM_BUILD_ROOT/%{_libdir}/libactivemq-cpp.so
rm  $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/activemq-cpp.pc
popd

pushd activemq-cpp-library-%{compattwover}
make install DESTDIR=$RPM_BUILD_ROOT
rm $RPM_BUILD_ROOT/%{_libdir}/lib%{name}.la
rm $RPM_BUILD_ROOT/%{_bindir}/example
# Remove the devel files from the compat package
# we only one the runtime stuff.
rm $RPM_BUILD_ROOT/%{_bindir}/activemqcpp-config
rm -rf $RPM_BUILD_ROOT/%{_includedir}/activemq-cpp-%{compattwover}
rm  $RPM_BUILD_ROOT/%{_libdir}/libactivemq-cpp.so
rm  $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/activemq-cpp.pc
popd

pushd activemq-cpp-library-%{compatthreever}
make install DESTDIR=$RPM_BUILD_ROOT
rm $RPM_BUILD_ROOT/%{_libdir}/lib%{name}.la
rm $RPM_BUILD_ROOT/%{_bindir}/example
# Remove the devel files from the compat package
# we only one the runtime stuff.
rm $RPM_BUILD_ROOT/%{_bindir}/activemqcpp-config
rm -rf $RPM_BUILD_ROOT/%{_includedir}/activemq-cpp-%{compatthreever}
rm  $RPM_BUILD_ROOT/%{_libdir}/libactivemq-cpp.so
rm  $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/activemq-cpp.pc
popd


make install DESTDIR=$RPM_BUILD_ROOT
rm $RPM_BUILD_ROOT/%{_libdir}/lib%{name}.la
rm $RPM_BUILD_ROOT/%{_bindir}/example

%clean
rm -rf $RPM_BUILD_ROOT

%check
make %{?_smp_mflags} check

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%{_libdir}/lib%{name}.so.%{normalso}*
%doc LICENSE.txt  NOTICE.txt  README.txt  RELEASE_NOTES.txt

%files devel
%defattr(-,root,root,-)
%{_libdir}/lib%{name}.so
%{_includedir}/%{name}-%{normalver}
%{_libdir}/pkgconfig/%{name}.pc
%{_bindir}/activemqcpp-config

%files doc
%defattr(-,root,root,-)
%doc doc/%{name}.pdf

%files compat
%defattr(-,root,root,-)
%{_libdir}/lib%{name}.so.%{compatso}*
%doc LICENSE.txt


%files -n  activemq-cpp%{compattwover}-compat
%defattr(-,root,root,-)
%{_libdir}/lib%{name}.so.%{compattwoso}*
%doc LICENSE.txt

%files -n  activemq-cpp%{compatthreever}-compat
%defattr(-,root,root,-)
%{_libdir}/lib%{name}.so.%{compatthreeso}*
%doc LICENSE.txt


%changelog
* Sat Oct 29 2011 Steve Traylen <steve.traylen@cern.ch> - 3.8.2-5
- Upstream to 3.8.2
- Add another compat package activemq-cpp3.7.0-compat

* Sat Oct 29 2011 Steve Traylen <steve.traylen@cern.ch> - 3.7.0-1
- Upstream to 3.7.0
- Add another compat activemq-cpp3.4.0-compat package.

* Sat Oct 29 2011 Steve Traylen <steve.traylen@cern.ch> - 3.4.0-2
- Fix rhbz#757629  and bump 3.2.5-3 compat package.

* Sat Oct 29 2011 Steve Traylen <steve.traylen@cern.ch> - 3.4.0-1
- Upstream to 3.4.0 and add a 3.2.5-2 compat package.

* Mon Mar 7 2011 Steve Traylen <steve.traylen@cern.ch> - 3.2.5-1
- autoconf step removed.
- Upstream to 3.2.5

* Mon Feb 07 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.2.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Feb 6 2011 Steve Traylen <steve.traylen@cern.ch> - 3.2.4-1
- Upstream to 3.2.4

* Wed Nov 10 2010 Steve Traylen <steve.traylen@cern.ch> - 3.2.3-1
- Upstream to 3.2.3

* Thu Jul 22 2010 Steve Traylen <steve.traylen@cern.ch> - 3.2.1-1
- Upstream to 3.2.1
- Add BR of openssl-devel since library now supports ssl 
  connections.

* Sat Apr 3 2010 Steve Traylen <steve.traylen@cern.ch> - 3.1.2-1
- Upstream to 3.1.2

* Sat Jan 9 2010 Steve Traylen <steve.traylen@cern.ch> - 3.1.0-1
- Upstream to 3.1.0

* Fri Dec 11 2009 Steve Traylen <steve.traylen@cern.ch> - 3.0.1-1
- Upstream to 3.0.1
- Tar ball name change.

* Fri Dec 11 2009 Steve Traylen <steve.traylen@cern.ch> - 2.2.6-5
- Add libuuid-devel as Requires to -devel package.

* Sat Nov 14 2009 Steve Traylen <steve.traylen@cern.ch> - 2.2.6-4
- Remove patch to relocate headers from versioned directory.
- Add make smp options to make check.

* Fri Nov 6 2009 Steve Traylen <steve.traylen@cern.ch> - 2.2.6-3
- Relocate headers to non versioned directory with patch0

* Fri Nov 6 2009 Steve Traylen <steve.traylen@cern.ch> - 2.2.6-2
- Adapted to Fedora guidelines.

* Thu Feb 26 2009 Ricardo Rocha <ricardo.rocha@cern.ch> - 2.2.6-1
- First version of the spec file


